BiMap
Date: 2016-05-24

com.google.common.collect

## Interface BiMap<K,V>

- All Superinterfaces:
    java.util.Map<K,V>
  All Known Implementing Classes:
    EnumBiMap, EnumHashBiMap, HashBiMap, ImmutableBiMap

      @GwtCompatible
      public interface BiMap<K,V>
      extends java.util.Map<K,V>

  A bimap (or "bidirectional map") is a map that preserves the uniqueness of its values as well as that of its keys. This constraint enables bimaps to support an "inverse view", which is another bimap containing the same entries as this bimap but with reversed keys and values.

  See the Guava User Guide article on `BiMap`.

  Since:
    2.0

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface java.util.Map

      `java.util.Map.Entry<K,V>`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `V` | `forcePut(K key, V value)` An alternate form of `put` that silently removes any existing entry with the value `value` before proceeding with the `put(K, V)` operation.
    `BiMap<V,K>` | `inverse()` Returns the inverse view of this bimap, which maps each of this bimap's values to its associated key.
    `V` | `put(K key, V value)`
    `void` | `putAll(java.util.Map<? extends K,? extends V> map)`
    `java.util.Set<V>` | `values()`

    - ### Methods inherited from interface java.util.Map

      `clear, containsKey, containsValue, entrySet, equals, get, hashCode, isEmpty, keySet, remove, size`

- - ### Method Detail

    - #### put

          @Nullable
          V put(@Nullable
                       K key,
                       @Nullable
                       V value)

      Specified by:
        `put` in interface `java.util.Map<K,V>`
      Throws:
        `java.lang.IllegalArgumentException` - if the given value is already bound to a different key in this bimap. The bimap will remain unmodified in this event. To avoid this exception, call `forcePut(K, V)` instead.

    - #### forcePut

          @Nullable
          V forcePut(@Nullable
                            K key,
                            @Nullable
                            V value)

      An alternate form of `put` that silently removes any existing entry with the value `value` before proceeding with the `put(K, V)` operation. If the bimap previously contained the provided key-value mapping, this method has no effect.

      Note that a successful call to this method could cause the size of the bimap to increase by one, stay the same, or even decrease by one.

      Warning: If an existing entry with this value is removed, the key for that entry is discarded and not returned.

      Parameters:
        `key` - the key with which the specified value is to be associated
        `value` - the value to be associated with the specified key
      Returns:
        the value which was previously associated with the key, which may be `null`, or `null` if there was no previous entry

    - #### putAll

          void putAll(java.util.Map<? extends K,? extends V> map)

      Warning: the results of calling this method may vary depending on the iteration order of `map`.

      Specified by:
        `putAll` in interface `java.util.Map<K,V>`
      Throws:
        `java.lang.IllegalArgumentException` - if an attempt to `put` any entry fails. Note that some map entries may have been added to the bimap before the exception was thrown.

    - #### values

          java.util.Set<V> values()

      Because a bimap has unique values, this method returns a `Set`, instead of the `Collection` specified in the `Map` interface.

      Specified by:
        `values` in interface `java.util.Map<K,V>`

    - #### inverse

          BiMap<V,K> inverse()

      Returns the inverse view of this bimap, which maps each of this bimap's values to its associated key. The two bimaps are backed by the same data; any changes to one will appear in the other.

      Note:There is no guaranteed correspondence between the iteration order of a bimap and that of its inverse.

      Returns:
        the inverse view of this bimap